<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Media Server: Googletest Mocking (gMock) Framework</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Media Server
   &#160;<span id="projectnumber">1.0</span>
   </div>
   <div id="projectbrief">Simple MediaServer with effects and filters</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('md__home_pi_medienserver_local_app_UILD_DOC_On__deps_googletest_src_googlemock_README.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Googletest Mocking (gMock) Framework </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h2><a class="anchor" id="autotoc_md255"></a>
Overview</h2>
<p>Google's framework for writing and using C++ mock classes. It can help you derive better designs of your system and write better tests.</p>
<p>It is inspired by:</p>
<ul>
<li><a href="http://www.jmock.org/">jMock</a></li>
<li><a href="http://www.easymock.org/">EasyMock</a></li>
<li><a href="http://code.google.com/p/hamcrest/">Hamcrest</a></li>
</ul>
<p>It is designed with C++'s specifics in mind.</p>
<p>gMock:</p>
<ul>
<li>Provides a declarative syntax for defining mocks.</li>
<li>Can define partial (hybrid) mocks, which are a cross of real and mock objects.</li>
<li>Handles functions of arbitrary types and overloaded functions.</li>
<li>Comes with a rich set of matchers for validating function arguments.</li>
<li>Uses an intuitive syntax for controlling the behavior of a mock.</li>
<li>Does automatic verification of expectations (no record-and-replay needed).</li>
<li>Allows arbitrary (partial) ordering constraints on function calls to be expressed.</li>
<li>Lets a user extend it by defining new matchers and actions.</li>
<li>Does not use exceptions.</li>
<li>Is easy to learn and use.</li>
</ul>
<p>Details and examples can be found here:</p>
<ul>
<li>/home/pi/medienserver/local_app/UILD_DOC=On/_deps/googletest-src/docs/gmock_for_dummies.md "gMock for Dummies"</li>
<li>/home/pi/medienserver/local_app/UILD_DOC=On/_deps/googletest-src/docs/gmock_faq.md "Legacy gMock FAQ"</li>
<li>/home/pi/medienserver/local_app/UILD_DOC=On/_deps/googletest-src/docs/gmock_cook_book.md "gMock Cookbook"</li>
<li>/home/pi/medienserver/local_app/UILD_DOC=On/_deps/googletest-src/docs/gmock_cheat_sheet.md "gMock Cheat Sheet"</li>
</ul>
<p>Please note that code under scripts/generator/ is from the <a href="http://code.google.com/p/cppclean/">cppclean project</a> and under the Apache License, which is different from GoogleMock's license.</p>
<p>GoogleMock is a part of <a href="http://github.com/google/googletest/">GoogleTest C++ testing framework</a> and a subject to the same requirements. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
